package cn.com.ty.chat.neety.process;

import cn.com.ty.chat.neety.protocol.IMMessage;
import cn.com.ty.chat.neety.support.WebSoketSupport;
import io.netty.channel.Channel;
import lombok.extern.slf4j.Slf4j;

import java.util.Optional;

/**
 * 用户登录websoket初始化操作类
 * 
 * @author sKing
 * @Date 2020年6月12日
 */
@Slf4j
public class LoginProcessor extends WebSoketSupport implements ProcessorInterface {

    /**
     * websoket消息处理
     * 
     * @param client
     * @param request
     */
    @Override
    public void process(Channel client, IMMessage request) {
        // 获取用户登录信息并放入链接中，
        String USER_NAME = request.getName();
        String USER_ID = request.getUserId();
        String AVATAR_URL = request.getAvatarUrl();

        client.attr(USERID).getAndSet(USER_ID);
        client.attr(USERNAME).getAndSet(USER_NAME);
        client.attr(HEAD_PIC).getAndSet(AVATAR_URL);
        client.attr(IP_ADDR).getAndSet(getAddress(client));

        //连接成功之后把链接与用户相关联，方便以后推送消息。
        Optional.ofNullable(userChannel.get(USER_ID)).ifPresent(channel -> {
            //如果重复登录退出原有登录，替换新的连接。
            logout(channel);
        });
        userChannel.put(USER_ID, client);
    }

}
